import functools
import sys


class _out:
    def __init__(self):
        self.dsp = ''
        self.stdout = sys.stdout

    def write(self, txt):
        txt = str(txt)
        self.stdout.write(txt)
        self.dsp += txt

    def flush(self):
        self.stdout.flush()


class _base_send_class:
    def send(self, *args, **kwargs):
        pass


class NOT_SEND:
    def __init__(self, RTN_CODE=None):
        self.rtn_code = RTN_CODE


def send(cls: _base_send_class):
    def decorator(func):
        @functools.wraps(func)
        def wrapper(*args, **kw):
            baseout, sys.stdout, isSend = sys.stdout, _out(), True
            try:
                rtn = func(*args, **kw)
                if type(rtn) is NOT_SEND:
                    isSend = False
                    rtn = rtn.rtn_code
                return rtn
            except Exception as e:
                print(str(e))
            finally:
                isSend and sys.stdout.dsp and cls.send(sys.stdout.dsp)
                sys.stdout = baseout

        return wrapper

    return decorator
