import os
import httpx

from .send import _base_send_class


class telegram(_base_send_class):
    def __init__(self, BOT_TOKEN, CHAT_ID, TG_API_HOST=os.getenv('TG_API_HOST')):
        self.BOT_TOKEN = BOT_TOKEN
        self.CHAT_ID = CHAT_ID
        self.TG_API_HOST = TG_API_HOST if TG_API_HOST else 'https://api.telegram.org'

    def send(self, msg):
        data = {
            'chat_id': self.CHAT_ID,
            'text': msg,
        }
        response = httpx.post(f'{self.TG_API_HOST}/bot{self.BOT_TOKEN}/sendMessage', data=data)
        if response.status_code != 200:
            return False
        else:
            return response.json()['ok']
