import re

import httpx


class smailPro:
    def __init__(self, rapidapi_key: str = None):
        self.rapidapi_key = rapidapi_key or self._getDefaltRapidApiKey()
        self.datas = dict()

    @staticmethod
    def _getDefaltRapidApiKey() -> str:
        rsp = httpx.get('https://smailpro.com/js/chunks/smailpro.js')
        return re.findall('rapidapi_key:"(.*?)"', rsp.text)[0]

    def newEmail(self) -> str:
        client = httpx.Client()
        data = {"username": "random", "domain": "gmail.com", "server": "server-1", "type": "alias"}
        response = client.post('https://smailpro.com/app/key', json=data)
        params = (
            ('key', response.json()['items']),
            ('rapidapi-key', self.rapidapi_key),
            ('username', 'random'),
            ('domain', 'gmail.com'),
            ('server', 'server-1'),
            ('type', 'alias'),
        )
        response = client.get('https://public-sonjj.p.rapidapi.com/email/gm/get', params=params)
        email = response.json()['items']['email']
        timestamp = response.json()['items']['timestamp']
        self.datas[email] = {'client': client, 'ts': timestamp}
        return email

    def getMail(self, email):
        if email not in self.datas:
            raise Exception('Email not exist!')
        client = self.datas[email]['client']
        ts = self.datas[email]['ts']

        data = {"email": email, "timestamp": ts, "server": "server-1", "type": "alias"}

        response = client.post('https://smailpro.com/app/key', json=data)
        # 获取邮件列表
        params = (
            ('key', response.json()['items']),
            ('rapidapi-key', self.rapidapi_key),
            ('email', email),
            ('timestamp', ts),
            ('server', 'server-1'),
            ('type', 'alias'),
        )

        response = client.get('https://public-sonjj.p.rapidapi.com/email/gm/check', params=params)
        mails = response.json()['items']
        if not mails:
            return None
        mails = mails[0]
        print(mails)
        mid = mails['mid']  # messageId
        textSubject = mails['textSubject']  # 邮件主题

        data = {"email": email, "message_id": mid, "server": "server-1", "type": "alias"}

        response = client.post('https://smailpro.com/app/key', json=data)

        params = (
            ('key', response.json()['items']),
            ('rapidapi-key', self.rapidapi_key),
            ('email', email),
            ('message_id', mid),
            ('server', 'server-1'),
            ('type', 'alias'),
        )

        response = client.get('https://public-sonjj.p.rapidapi.com/email/gm/read', params=params)
        print(response.json())
        return {'subject': textSubject, 'content': response.json()['items']['body']}
