import datetime
import threading
from concurrent.futures import ThreadPoolExecutor, Future
from typing import List


class tpool(ThreadPoolExecutor):
    def show(self, task: List[Future], name='', block=True):
        finish = threading.Lock()
        finish.acquire()

        def check():
            self.shutdown()
            finish.release()

        threading.Thread(target=check).start()

        def show_():
            nonlocal task
            begin = datetime.datetime.now()
            print(f'{name} 开始 {begin.strftime("%H:%M:%S")}')

            while not finish.acquire(timeout=3):
                task = list(filter(lambda x: not Future.done(x), task))
                print(f'{name} 还剩 {len(task)} 任务')
            end = datetime.datetime.now()
            print(f'{name} 完成 {end.strftime("%H:%M:%S")} 耗时 {str(end - begin).split(".")[0]}')

        show_() if block else threading.Thread(target=show_).start()
